(function(B,A){angular.module("toaster",[]).constant("toasterConfig",{limit:0,"tap-to-dismiss":true,"close-button":false,"close-html":'<button class="toast-close-button" type="button">&times;</button>',"newest-on-top":true,"time-out":5000,"icon-classes":{error:"toast-error",info:"toast-info",wait:"toast-wait",success:"toast-success",warning:"toast-warning"},"body-output-type":"","body-template":"toasterBodyTmpl.html","icon-class":"toast-info","position-class":"toast-top-right","title-class":"toast-title","message-class":"toast-message","prevent-duplicates":false,"mouseover-timer-stop":true}).service("toaster",["$rootScope","toasterConfig",function(C,E){this.pop=function(N,P,K,O,J,M,Q,H,G,L){if(angular.isObject(N)){var I=N;
this.toast={type:I.type,title:I.title,body:I.body,timeout:I.timeout,bodyOutputType:I.bodyOutputType,clickHandler:I.clickHandler,showCloseButton:I.showCloseButton,closeHtml:I.closeHtml,uid:I.toastId,onShowCallback:I.onShowCallback,onHideCallback:I.onHideCallback,directiveData:I.directiveData};
G=I.toastId;
Q=I.toasterId;
}else{this.toast={type:N,title:P,body:K,timeout:O,bodyOutputType:J,clickHandler:M,showCloseButton:H,uid:G,onHideCallback:L};
}C.$emit("toaster-newToast",Q,G);
};
this.clear=function(G,H){C.$emit("toaster-clearToasts",G,H);
};
for(var F in E["icon-classes"]){this[F]=D(F);
}function D(G){return function(O,K,N,J,M,P,H,I,L){if(angular.isString(O)){this.pop(G,O,K,N,J,M,P,H,I,L);
}else{this.pop(angular.extend(O,{type:G}));
}};
}}]).factory("toasterEventRegistry",["$rootScope",function(D){var C=null,E=null,H=[],F=[],G;
G={setup:function(){if(!C){C=D.$on("toaster-newToast",function(M,J,L){for(var K=0,I=H.length;
K<I;
K++){H[K](M,J,L);
}});
}if(!E){E=D.$on("toaster-clearToasts",function(M,J,L){for(var K=0,I=F.length;
K<I;
K++){F[K](M,J,L);
}});
}},subscribeToNewToastEvent:function(I){H.push(I);
},subscribeToClearToastsEvent:function(I){F.push(I);
},unsubscribeToNewToastEvent:function(J){var I=H.indexOf(J);
if(I>=0){H.splice(I,1);
}if(H.length===0){C();
C=null;
}},unsubscribeToClearToastsEvent:function(J){var I=F.indexOf(J);
if(I>=0){F.splice(I,1);
}if(F.length===0){E();
E=null;
}}};
return{setup:G.setup,subscribeToNewToastEvent:G.subscribeToNewToastEvent,subscribeToClearToastsEvent:G.subscribeToClearToastsEvent,unsubscribeToNewToastEvent:G.unsubscribeToNewToastEvent,unsubscribeToClearToastsEvent:G.unsubscribeToClearToastsEvent};
}]).directive("directiveTemplate",["$compile","$injector",function(C,D){return{restrict:"A",scope:{directiveName:"@directiveName",directiveData:"@directiveData"},replace:true,link:function(F,G,E){F.$watch("directiveName",function(L){if(angular.isUndefined(L)||L.length<=0){throw new Error("A valid directive name must be provided via the toast body argument when using bodyOutputType: directive");
}var K;
try{K=D.get(E.$normalize(L)+"Directive");
}catch(J){throw new Error(L+" could not be found. The name should appear as it exists in the markup, not camelCased as it would appear in the directive declaration, e.g. directive-name not directiveName.");
}var I=K[0];
if(I.scope!==true&&I.scope){throw new Error("Cannot use a directive with an isolated scope. The scope must be either true or falsy (e.g. false/null/undefined). Occurred for directive "+L+".");
}if(I.restrict.indexOf("A")<0){throw new Error('Directives must be usable as attributes. Add "A" to the restrict option (or remove the option entirely). Occurred for directive '+L+".");
}if(F.directiveData){F.directiveData=angular.fromJson(F.directiveData);
}var H=C("<div "+L+"></div>")(F);
G.append(H);
});
}};
}]).directive("toasterContainer",["$parse","$rootScope","$interval","$sce","toasterConfig","toaster","toasterEventRegistry",function(H,D,I,F,E,G,C){return{replace:true,restrict:"EA",scope:true,link:function(R,P,Q){var K=0,S;
S=angular.extend({},E,R.$eval(Q.toasterOptions));
R.config={toasterId:S["toaster-id"],position:S["position-class"],title:S["title-class"],message:S["message-class"],tap:S["tap-to-dismiss"],closeButton:S["close-button"],closeHtml:S["close-html"],animation:S["animation-class"],mouseoverTimer:S["mouseover-timer-stop"]};
R.$on("$destroy",function(){C.unsubscribeToNewToastEvent(R._onNewToast);
C.unsubscribeToClearToastsEvent(R._onClearToasts);
});
function N(T,U){T.timeoutPromise=I(function(){R.removeToast(T.id);
},U,1);
}R.configureTimer=function(T){var U=angular.isNumber(T.timeout)?T.timeout:S["time-out"];
if(typeof U==="object"){U=U[T.type];
}if(U>0){N(T,U);
}};
function L(U,Y){U.type=S["icon-classes"][U.type];
if(!U.type){U.type=S["icon-class"];
}if(S["prevent-duplicates"]===true){if(J(Y)){if(R.toasters.length>0&&R.toasters[R.toasters.length-1].body===U.body){return ;
}}else{var X,T;
for(X=0,T=R.toasters.length;
X<T;
X++){if(R.toasters[X].uid===Y){O(X);
X--;
T=R.toasters.length;
}}}}U.id=++K;
if(!J(Y)){U.uid=Y;
}var W=S["close-button"];
if(typeof U.showCloseButton==="boolean"){}else{if(typeof W==="boolean"){U.showCloseButton=W;
}else{if(typeof W==="object"){var Z=W[U.type];
if(typeof Z!=="undefined"&&Z!==null){U.showCloseButton=Z;
}}else{U.showCloseButton=false;
}}}if(U.showCloseButton){U.closeHtml=F.trustAsHtml(U.closeHtml||R.config.closeHtml);
}U.bodyOutputType=U.bodyOutputType||S["body-output-type"];
switch(U.bodyOutputType){case"trustedHtml":U.html=F.trustAsHtml(U.body);
break;
case"template":U.bodyTemplate=U.body||S["body-template"];
break;
case"templateWithData":var a=H(U.body||S["body-template"]);
var V=a(R);
U.bodyTemplate=V.template;
U.data=V.data;
break;
case"directive":U.html=U.body;
break;
}R.configureTimer(U);
if(S["newest-on-top"]===true){R.toasters.unshift(U);
if(S.limit>0&&R.toasters.length>S.limit){R.toasters.pop();
}}else{R.toasters.push(U);
if(S.limit>0&&R.toasters.length>S.limit){R.toasters.shift();
}}if(angular.isFunction(U.onShowCallback)){U.onShowCallback();
}}R.removeToast=function(V){var U,T;
for(U=0,T=R.toasters.length;
U<T;
U++){if(R.toasters[U].id===V){O(U);
break;
}}};
function O(U){var T=R.toasters[U];
if(T.timeoutPromise){I.cancel(T.timeoutPromise);
}R.toasters.splice(U,1);
if(angular.isFunction(T.onHideCallback)){T.onHideCallback();
}}function M(U){for(var T=R.toasters.length-1;
T>=0;
T--){if(J(U)){O(T);
}else{if(R.toasters[T].uid==U){O(T);
}}}}R.toasters=[];
function J(T){return angular.isUndefined(T)||T===null;
}R._onNewToast=function(V,T,U){if((J(R.config.toasterId)&&J(T))||(!J(R.config.toasterId)&&!J(T)&&R.config.toasterId==T)){L(G.toast,U);
}};
R._onClearToasts=function(V,T,U){if(T=="*"||(J(R.config.toasterId)&&J(T))||(!J(R.config.toasterId)&&!J(T)&&R.config.toasterId==T)){M(U);
}};
C.setup();
C.subscribeToNewToastEvent(R._onNewToast);
C.subscribeToClearToastsEvent(R._onClearToasts);
},controller:["$scope","$element","$attrs",function(L,K,J){L.stopTimer=function(M){if(L.config.mouseoverTimer===true){if(M.timeoutPromise){I.cancel(M.timeoutPromise);
M.timeoutPromise=null;
}}};
L.restartTimer=function(M){if(L.config.mouseoverTimer===true){if(!M.timeoutPromise){L.configureTimer(M);
}}else{if(M.timeoutPromise===null){L.removeToast(M.id);
}}};
L.click=function(M,O){if(L.config.tap===true||(M.showCloseButton===true&&O===true)){var N=true;
if(M.clickHandler){if(angular.isFunction(M.clickHandler)){N=M.clickHandler(M,O);
}else{if(angular.isFunction(L.$parent.$eval(M.clickHandler))){N=L.$parent.$eval(M.clickHandler)(M,O);
}else{console.log("TOAST-NOTE: Your click handler is not inside a parent scope of toaster-container.");
}}}if(N){L.removeToast(M.id);
}}};
}],template:'<div id="toast-container" ng-class="[config.position, config.animation]"><div ng-repeat="toaster in toasters" class="toast" ng-class="toaster.type" ng-click="click(toaster)" ng-mouseover="stopTimer(toaster)" ng-mouseout="restartTimer(toaster)"><div ng-if="toaster.showCloseButton" ng-click="click(toaster, true)" ng-bind-html="toaster.closeHtml"></div><div ng-class="config.title">{{toaster.title}}</div><div ng-class="config.message" ng-switch on="toaster.bodyOutputType"><div ng-switch-when="trustedHtml" ng-bind-html="toaster.html"></div><div ng-switch-when="template"><div ng-include="toaster.bodyTemplate"></div></div><div ng-switch-when="templateWithData"><div ng-include="toaster.bodyTemplate"></div></div><div ng-switch-when="directive"><div directive-template directive-name="{{toaster.html}}" directive-data="{{toaster.directiveData}}"></div></div><div ng-switch-default >{{toaster.body}}</div></div></div></div>'};
}]);
})(window,document);
