!function(A,B){angular.module("toaster",[]).constant("toasterConfig",{limit:0,"tap-to-dismiss":!0,"close-button":!1,"close-html":'<button class="toast-close-button" type="button">&times;</button>',"newest-on-top":!0,"time-out":5000,"icon-classes":{error:"toast-error",info:"toast-info",wait:"toast-wait",success:"toast-success",warning:"toast-warning"},"body-output-type":"","body-template":"toasterBodyTmpl.html","icon-class":"toast-info","position-class":"toast-top-right","title-class":"toast-title","message-class":"toast-message","prevent-duplicates":!1,"mouseover-timer-stop":!0}).service("toaster",["$rootScope","toasterConfig",function(C,E){function F(G){return function(M,I,P,L,O,J,H,N,K){angular.isString(M)?this.pop(G,M,I,P,L,O,J,H,N,K):this.pop(angular.extend(M,{type:G}));
};
}this.pop=function(L,H,Q,K,O,I,G,N,J,P){if(angular.isObject(L)){var M=L;
this.toast={type:M.type,title:M.title,body:M.body,timeout:M.timeout,bodyOutputType:M.bodyOutputType,clickHandler:M.clickHandler,showCloseButton:M.showCloseButton,closeHtml:M.closeHtml,uid:M.toastId,onShowCallback:M.onShowCallback,onHideCallback:M.onHideCallback,directiveData:M.directiveData},J=M.toastId,G=M.toasterId;
}else{this.toast={type:L,title:H,body:Q,timeout:K,bodyOutputType:O,clickHandler:I,showCloseButton:N,uid:J,onHideCallback:P};
}C.$emit("toaster-newToast",G,J);
},this.clear=function(G,H){C.$emit("toaster-clearToasts",G,H);
};
for(var D in E["icon-classes"]){this[D]=F(D);
}}]).factory("toasterEventRegistry",["$rootScope",function(E){var G,H=null,F=null,D=[],C=[];
return G={setup:function(){H||(H=E.$on("toaster-newToast",function(J,L,M){for(var K=0,I=D.length;
I>K;
K++){D[K](J,L,M);
}})),F||(F=E.$on("toaster-clearToasts",function(J,L,M){for(var K=0,I=C.length;
I>K;
K++){C[K](J,L,M);
}}));
},subscribeToNewToastEvent:function(I){D.push(I);
},subscribeToClearToastsEvent:function(I){C.push(I);
},unsubscribeToNewToastEvent:function(I){var J=D.indexOf(I);
J>=0&&D.splice(J,1),0===D.length&&(H(),H=null);
},unsubscribeToClearToastsEvent:function(I){var J=C.indexOf(I);
J>=0&&C.splice(J,1),0===C.length&&(F(),F=null);
}},{setup:G.setup,subscribeToNewToastEvent:G.subscribeToNewToastEvent,subscribeToClearToastsEvent:G.subscribeToClearToastsEvent,unsubscribeToNewToastEvent:G.unsubscribeToNewToastEvent,unsubscribeToClearToastsEvent:G.unsubscribeToClearToastsEvent};
}]).directive("directiveTemplate",["$compile","$injector",function(C,D){return{restrict:"A",scope:{directiveName:"@directiveName",directiveData:"@directiveData"},replace:!0,link:function(G,F,E){G.$watch("directiveName",function(I){if(angular.isUndefined(I)||I.length<=0){throw new Error("A valid directive name must be provided via the toast body argument when using bodyOutputType: directive");
}var L;
try{L=D.get(E.$normalize(I)+"Directive");
}catch(J){throw new Error(I+" could not be found. The name should appear as it exists in the markup, not camelCased as it would appear in the directive declaration, e.g. directive-name not directiveName.");
}var K=L[0];
if(K.scope!==!0&&K.scope){throw new Error("Cannot use a directive with an isolated scope. The scope must be either true or falsy (e.g. false/null/undefined). Occurred for directive "+I+".");
}if(K.restrict.indexOf("A")<0){throw new Error('Directives must be usable as attributes. Add "A" to the restrict option (or remove the option entirely). Occurred for directive '+I+".");
}G.directiveData&&(G.directiveData=angular.fromJson(G.directiveData));
var H=C("<div "+I+"></div>")(G);
F.append(H);
});
}};
}]).directive("toasterContainer",["$parse","$rootScope","$interval","$sce","toasterConfig","toaster","toasterEventRegistry",function(E,G,H,F,D,C,I){return{replace:!0,restrict:"EA",scope:!0,link:function(O,J,Q){function M(T,U){T.timeoutPromise=H(function(){O.removeToast(T.id);
},U,1);
}function S(Y,W){if(Y.type=R["icon-classes"][Y.type],Y.type||(Y.type=R["icon-class"]),R["prevent-duplicates"]===!0){if(K(W)){if(O.toasters.length>0&&O.toasters[O.toasters.length-1].body===Y.body){return ;
}}else{var U,b;
for(U=0,b=O.toasters.length;
b>U;
U++){O.toasters[U].uid===W&&(P(U),U--,b=O.toasters.length);
}}}Y.id=++N,K(W)||(Y.uid=W);
var X=R["close-button"];
if("boolean"==typeof Y.showCloseButton){}else{if("boolean"==typeof X){Y.showCloseButton=X;
}else{if("object"==typeof X){var Z=X[Y.type];
"undefined"!=typeof Z&&null!==Z&&(Y.showCloseButton=Z);
}else{Y.showCloseButton=!1;
}}}switch(Y.showCloseButton&&(Y.closeHtml=F.trustAsHtml(Y.closeHtml||O.config.closeHtml)),Y.bodyOutputType=Y.bodyOutputType||R["body-output-type"],Y.bodyOutputType){case"trustedHtml":Y.html=F.trustAsHtml(Y.body);
break;
case"template":Y.bodyTemplate=Y.body||R["body-template"];
break;
case"templateWithData":var T=E(Y.body||R["body-template"]),V=T(O);
Y.bodyTemplate=V.template,Y.data=V.data;
break;
case"directive":Y.html=Y.body;
}O.configureTimer(Y),R["newest-on-top"]===!0?(O.toasters.unshift(Y),R.limit>0&&O.toasters.length>R.limit&&O.toasters.pop()):(O.toasters.push(Y),R.limit>0&&O.toasters.length>R.limit&&O.toasters.shift()),angular.isFunction(Y.onShowCallback)&&Y.onShowCallback();
}function P(T){var U=O.toasters[T];
U.timeoutPromise&&H.cancel(U.timeoutPromise),O.toasters.splice(T,1),angular.isFunction(U.onHideCallback)&&U.onHideCallback();
}function L(T){for(var U=O.toasters.length-1;
U>=0;
U--){K(T)?P(U):O.toasters[U].uid==T&&P(U);
}}function K(T){return angular.isUndefined(T)||null===T;
}var R,N=0;
R=angular.extend({},D,O.$eval(Q.toasterOptions)),O.config={toasterId:R["toaster-id"],position:R["position-class"],title:R["title-class"],message:R["message-class"],tap:R["tap-to-dismiss"],closeButton:R["close-button"],closeHtml:R["close-html"],animation:R["animation-class"],mouseoverTimer:R["mouseover-timer-stop"]},O.$on("$destroy",function(){I.unsubscribeToNewToastEvent(O._onNewToast),I.unsubscribeToClearToastsEvent(O._onClearToasts);
}),O.configureTimer=function(T){var U=angular.isNumber(T.timeout)?T.timeout:R["time-out"];
"object"==typeof U&&(U=U[T.type]),U>0&&M(T,U);
},O.removeToast=function(T){var V,U;
for(V=0,U=O.toasters.length;
U>V;
V++){if(O.toasters[V].id===T){P(V);
break;
}}},O.toasters=[],O._onNewToast=function(T,V,U){(K(O.config.toasterId)&&K(V)||!K(O.config.toasterId)&&!K(V)&&O.config.toasterId==V)&&S(C.toast,U);
},O._onClearToasts=function(T,V,U){("*"==V||K(O.config.toasterId)&&K(V)||!K(O.config.toasterId)&&!K(V)&&O.config.toasterId==V)&&L(U);
},I.setup(),I.subscribeToNewToastEvent(O._onNewToast),I.subscribeToClearToastsEvent(O._onClearToasts);
},controller:["$scope","$element","$attrs",function(J,L,K){J.stopTimer=function(M){J.config.mouseoverTimer===!0&&M.timeoutPromise&&(H.cancel(M.timeoutPromise),M.timeoutPromise=null);
},J.restartTimer=function(M){J.config.mouseoverTimer===!0?M.timeoutPromise||J.configureTimer(M):null===M.timeoutPromise&&J.removeToast(M.id);
},J.click=function(N,O){if(J.config.tap===!0||N.showCloseButton===!0&&O===!0){var M=!0;
N.clickHandler&&(angular.isFunction(N.clickHandler)?M=N.clickHandler(N,O):angular.isFunction(J.$parent.$eval(N.clickHandler))?M=J.$parent.$eval(N.clickHandler)(N,O):console.log("TOAST-NOTE: Your click handler is not inside a parent scope of toaster-container.")),M&&J.removeToast(N.id);
}};
}],template:'<div id="toast-container" ng-class="[config.position, config.animation]"><div ng-repeat="toaster in toasters" class="toast" ng-class="toaster.type" ng-click="click(toaster)" ng-mouseover="stopTimer(toaster)" ng-mouseout="restartTimer(toaster)"><div ng-if="toaster.showCloseButton" ng-click="click(toaster, true)" ng-bind-html="toaster.closeHtml"></div><div ng-class="config.title">{{toaster.title}}</div><div ng-class="config.message" ng-switch on="toaster.bodyOutputType"><div ng-switch-when="trustedHtml" ng-bind-html="toaster.html"></div><div ng-switch-when="template"><div ng-include="toaster.bodyTemplate"></div></div><div ng-switch-when="templateWithData"><div ng-include="toaster.bodyTemplate"></div></div><div ng-switch-when="directive"><div directive-template directive-name="{{toaster.html}}" directive-data="{{toaster.directiveData}}"></div></div><div ng-switch-default >{{toaster.body}}</div></div></div></div>'};
}]);
}(window,document);
