/**
 * Created by mr_der on 16/2/23.
 */

var hygeaUrl=document.getElementById("hygeaDominUrl").value;
require.config({
    paths: {
        'angular': 'assets/libs/angular/angular.min',
        'angular-ui-router': 'assets/libs/angular-ui-router/release/angular-ui-router.min',
        'oc.lazyLoad': 'assets/libs/jquery/ocLazyLoad.require.min',
        'angular-resource': 'assets/libs/angular-resource/angular-resource.min',
        'zepto': 'assets/libs/zepto/zepto.min',
        'angular-animate': 'assets/libs/angular-animate/angular-animate.min',
        'AngularJS-Toaster': 'assets/libs/AngularJS-Toaster/toaster.min',
        'angular-local-storage': 'assets/libs/angular-local-storage/dist/angular-local-storage.min',
        'me-lazyload': 'assets/libs/jquery/me-lazyload',
        'jquery': 'assets/libs/jquery/jquery.min',
        'move': 'assets/libs/jquery/jquery.event.move.min',
        'swipe': 'assets/libs/jquery/jquery.event.swipe.min',
        'unslider': 'assets/libs/jquery/unslider.min',
        'aes' : 'assets/libs/aes/aes-min',
        'md5' : 'assets/libs/aes/md5-min',
        'evpkdf' : 'assets/libs/aes/evpkdf-min',
        'enc-base64' : 'assets/libs/aes/enc-base64-min',
        'core' : 'assets/libs/aes/core-min',
        'cipher-core' : 'assets/libs/aes/cipher-core-min',
        'sha1' :'assets/libs/aes/sha1-min',
        'crypto-js' :'assets/libs/aes/crypto-js-min',
        'mobiscroll': 'assets/libs/jquery/mobiscroll.custom-2.6.2.min',
        'angular-locale_zh': 'assets/libs/angular/angular-locale_zh-min',
        'angular-touch':'assets/libs/angular-touch/angular-touch.min',
        'customiseddatepicker':hygeaUrl+'common/webapp/shared/customiseddatepicker-min',      
        'common.resource':hygeaUrl+'common/webapp/shared/common.resource',
        'shared/controllers':hygeaUrl+'common/webapp/shared/controllers',
        'shared/services':hygeaUrl+'common/webapp/shared/services',
        'shared/filters':hygeaUrl+'common/webapp/shared/filters',
        'shared/directives':hygeaUrl+'common/webapp/shared/directives',
        'shared/config':hygeaUrl+'common/webapp/shared/config',
        'shared/utils':hygeaUrl+'common/webapp/shared/utils'
    },
    waitSeconds: 0,
    shim: {
        'angular': {
            exports: 'angular'
        },
        'angular-ui-router': {
            deps: ['angular']
        },
    	'oc.lazyLoad':{
        	deps: ['angular']
        },
        'angular-resource': {
            deps: ['angular']
        },
        'angular-animate': {
            deps: ['angular']
        },
        'AngularJS-Toaster': {
            deps: ['angular']
        },
        'angular-local-storage': {
            deps: ['angular']
        },
        'angular-touch':{
        	deps: ['angular']
        },
        'angular-locale_zh':{
        	deps: ['angular']
        },
        'customiseddatepicker':{
        	deps: ['angular']
        },
        'me-lazyload': {
        	deps: ['angular']
        },
        'common.resource':{
        	deps: ['angular']
        },
        'jquery': {
        	deps: ['angular']
        },
        'move': {
        	deps: ['jquery']
        },
        'swipe': {
        	deps: ['jquery']
        },
        'unslider': {
        	deps: ['jquery']
        },
        'zepto': {
            exports: '$'
        },
       
        'appstore': {
            deps: ['angular', 'oc.lazyLoad',hygeaUrl+'common/webapp/shared/controllers', hygeaUrl+'common/webapp/shared/services']
        },
        
        'mobiscroll': {
        	deps: ['jquery']
        }
    }    
});

require(['angular', hygeaUrl+ 'common/webapp/appstore.js'], function (angular) {
    angular.bootstrap(document, ['webApp']);
});
