(function(D,F){var G=F.isDefined,B=F.isUndefined,H=F.isNumber,I=F.isObject,C=F.isArray,E=F.extend,A=F.toJson;
F.module("LocalStorageModule",[]).provider("localStorageService",function(){this.prefix="ls";
this.storageType="localStorage";
this.cookie={expiry:30,path:"/"};
this.notify={setItem:true,removeItem:false};
this.setPrefix=function(J){this.prefix=J;
return this;
};
this.setStorageType=function(J){this.storageType=J;
return this;
};
this.setStorageCookie=function(K,J){this.cookie.expiry=K;
this.cookie.path=J;
return this;
};
this.setStorageCookieDomain=function(J){this.cookie.domain=J;
return this;
};
this.setNotify=function(J,K){this.notify={setItem:J,removeItem:K};
return this;
};
this.$get=["$rootScope","$window","$document","$parse",function(Q,Y,f,N){var Z=this;
var b=Z.prefix;
var e=Z.cookie;
var W=Z.notify;
var d=Z.storageType;
var a;
if(!f){f=document;
}else{if(f[0]){f=f[0];
}}if(b.substr(-1)!=="."){b=!!b?b+".":"";
}var R=function(i){return b+i;
};
var X=(function(){try{var i=(d in Y&&Y[d]!==null);
var j=R("__"+Math.round(Math.random()*10000000));
if(i){a=Y[d];
a.setItem(j,"");
a.removeItem(j);
}return i;
}catch(k){d="cookie";
Q.$broadcast("LocalStorageModule.notification.error",k.message);
return false;
}}());
var V=function(i,j){if(B(j)){j=null;
}else{j=A(j);
}if(!X||Z.storageType==="cookie"){if(!X){Q.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED");
}if(W.setItem){Q.$broadcast("LocalStorageModule.notification.setitem",{key:i,newvalue:j,storageType:"cookie"});
}return T(i,j);
}try{if(a){a.setItem(R(i),j);
}if(W.setItem){Q.$broadcast("LocalStorageModule.notification.setitem",{key:i,newvalue:j,storageType:Z.storageType});
}}catch(k){Q.$broadcast("LocalStorageModule.notification.error",k.message);
return T(i,j);
}return true;
};
var U=function(i){if(!X||Z.storageType==="cookie"){if(!X){Q.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED");
}return S(i);
}var j=a?a.getItem(R(i)):null;
if(!j||j==="null"){return null;
}try{return JSON.parse(j);
}catch(k){return j;
}};
var M=function(){var k,j;
for(k=0;
k<arguments.length;
k++){j=arguments[k];
if(!X||Z.storageType==="cookie"){if(!X){Q.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED");
}if(W.removeItem){Q.$broadcast("LocalStorageModule.notification.removeitem",{key:j,storageType:"cookie"});
}L(j);
}else{try{a.removeItem(R(j));
if(W.removeItem){Q.$broadcast("LocalStorageModule.notification.removeitem",{key:j,storageType:Z.storageType});
}}catch(l){Q.$broadcast("LocalStorageModule.notification.error",l.message);
L(j);
}}}};
var K=function(){if(!X){Q.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED");
return[];
}var i=b.length;
var k=[];
for(var j in a){if(j.substr(0,i)===b){try{k.push(j.substr(i));
}catch(l){Q.$broadcast("LocalStorageModule.notification.error",l.Description);
return[];
}}}return k;
};
var P=function(i){var n=!!b?new RegExp("^"+b):new RegExp();
var l=!!i?new RegExp(i):new RegExp();
if(!X||Z.storageType==="cookie"){if(!X){Q.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED");
}return h();
}var j=b.length;
for(var k in a){if(n.test(k)&&l.test(k.substr(j))){try{M(k.substr(j));
}catch(m){Q.$broadcast("LocalStorageModule.notification.error",m.message);
return h();
}}}return true;
};
var c=(function(){try{return Y.navigator.cookieEnabled||("cookie" in f&&(f.cookie.length>0||(f.cookie="test").indexOf.call(f.cookie,"test")>-1));
}catch(i){Q.$broadcast("LocalStorageModule.notification.error",i.message);
return false;
}}());
var T=function(n,o,m){if(B(o)){return false;
}else{if(C(o)||I(o)){o=A(o);
}}if(!c){Q.$broadcast("LocalStorageModule.notification.error","COOKIES_NOT_SUPPORTED");
return false;
}try{var l="",j=new Date(),i="";
if(o===null){j.setTime(j.getTime()+(-1*24*60*60*1000));
l="; expires="+j.toGMTString();
o="";
}else{if(H(m)&&m!==0){j.setTime(j.getTime()+(m*24*60*60*1000));
l="; expires="+j.toGMTString();
}else{if(e.expiry!==0){j.setTime(j.getTime()+(e.expiry*24*60*60*1000));
l="; expires="+j.toGMTString();
}}}if(!!n){var k="; path="+e.path;
if(e.domain){i="; domain="+e.domain;
}f.cookie=R(n)+"="+encodeURIComponent(o)+l+k+i;
}}catch(p){Q.$broadcast("LocalStorageModule.notification.error",p.message);
return false;
}return true;
};
var S=function(l){if(!c){Q.$broadcast("LocalStorageModule.notification.error","COOKIES_NOT_SUPPORTED");
return false;
}var m=f.cookie&&f.cookie.split(";")||[];
for(var k=0;
k<m.length;
k++){var j=m[k];
while(j.charAt(0)===" "){j=j.substring(1,j.length);
}if(j.indexOf(R(l)+"=")===0){var n=decodeURIComponent(j.substring(b.length+l.length+1,j.length));
try{return JSON.parse(n);
}catch(o){return n;
}}}return null;
};
var L=function(i){T(i,null);
};
var h=function(){var k=null,n=null;
var j=b.length;
var o=f.cookie.split(";");
for(var m=0;
m<o.length;
m++){k=o[m];
while(k.charAt(0)===" "){k=k.substring(1,k.length);
}var l=k.substring(j,k.indexOf("="));
L(l);
}};
var J=function(){return d;
};
var O=function(j,i,m,k){k=k||i;
var l=U(k);
if(l===null&&G(m)){l=m;
}else{if(I(l)&&I(m)){l=E(l,m);
}}N(i).assign(j,l);
return j.$watch(i,function(n){V(k,n);
},I(j[i]));
};
var g=function(){var k=0;
var l=Y[d];
for(var j=0;
j<l.length;
j++){if(l.key(j).indexOf(b)===0){k++;
}}return k;
};
return{isSupported:X,getStorageType:J,set:V,add:V,get:U,keys:K,remove:M,clearAll:P,bind:O,deriveKey:R,length:g,cookie:{isSupported:c,set:T,add:T,get:S,remove:L,clearAll:h}};
}];
});
})(window,window.angular);
